Subject: Re: [netconf] Question about RFC 6242 : netconf over ssh

From: Juergen Schoenwaelder <[email-masked]>
Date: Fri, 10 Jul 2020 22:46:45 +0200

On Mon, Jun 08, 2020 at 03:39:01PM +0000, Jeffrey Ladouceur (jladouce) wrote:
> Hello,
> 
> It's my understanding that running netconf over a pseudo terminal via ssh (i.e. pty-req) is most likely not a widely supported use-case as I don't see any refence to such use-case.
> 
> The pseudo terminal is typically used by an ssh client when the program on the server side expect to interreact with a terminal. To the best of my knowledge, a netconf server has no expectation, and in-fact may expect to be directly connected to the ssh server instance and not to a pty device.

I think that requesting a pty is a client error, NETCONF is not
designed to be used as an interactive terminal session.
 
> Would it be reasonable for a netconf subsytem to sanitize its STDIN/STDOUT/STDERR and if they were attached to a tty to exit and drop the connection ?

RFC 6242 is silent about what happens if SSH protocol features are
used that do not make much sense for NETCONF and hence it is
implementation specific how such situations are handled. Signaling the
allocation of a pty as an error seems to be a good thing (but I do not
know how 'popular' this is).

/js

-- 
Juergen Schoenwaelder           Jacobs University Bremen gGmbH
Phone: +49 421 200 3587         Campus Ring 1 | 28759 Bremen | Germany
Fax:   +49 421 200 3103         <https://www.jacobs-university.de/>